<%@ Assembly Name="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Page Language="C#" Inherits="Microsoft.SharePoint.WebPartPages.WikiEditPage" 
    MasterPageFile="~masterurl/default.master" %>
<%@ Register TagPrefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" 
    Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitle' runat='server'>
    Manage Role Assignments
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitleInTitleArea' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderAdditionalPageHead' runat='server'>
    <WebPartPages:AllowFraming runat="server"></WebPartPages:AllowFraming>
    <script src="https://cdn.jsdelivr.net/npm/es6-promise@4/dist/es6-promise.auto.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/whatwg-fetch@2.0.4/fetch.js"></script>
    <style type="text/css">
        h1 {
            margin-bottom: 10px;
        }
        
        table.multi-select-outer {
            width: 800px;
        }
        
        .multi-select-outer td {
            vertical-align: top;
            padding-bottom: 20px;
        }

        .multi-select-left {
            display: inline-block;
        }

        .multi-select-center {
            display: inline-block;
            padding-right: 8px;
            position: relative;
            top: 20px;
        }

        .multi-select-right {
            display: inline-block;
        }

        .list-available-select,
        .list-selected-select,
        .roledefinition-available-select,
        .roledefinition-selected-select {
            width: 250px;
            overflow: auto;
        }

        .list-available-select,
        .list-selected-select {
            height: 300px;
        }

        .roledefinition-available-select,
        .roledefinition-selected-select {
            height: 200px;
        }

        .multi-select-button {
            width: 90px;
        }
        
        .spinner-overlay {
            content: '';
            display: block;
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgba(0, 0, 0, 0.3);
            z-index: 999;
        }

        .spinner {
            height: 60px;
            width: 60px;
            margin: auto;
            position: fixed;
            top: 0;
            bottom: 0;
            left: 0;
            right: 0;
            -webkit-animation: rotation 2s infinite linear;
            -moz-animation: rotation 2s infinite linear;
            -o-animation: rotation 2s infinite linear;
            animation: rotation 2s infinite linear;
            border: 6px solid rgba(0, 111, 198, .25);
            border-radius: 100%;
            z-index: 998;
        }

        .spinner:before {
            content: "";
            display: block;
            position: absolute;
            left: -6px;
            top: -6px;
            height: 100%;
            width: 100%;
            border-top: 6px solid rgba(0, 111, 198, 1);
            border-left: 6px solid transparent;
            border-bottom: 6px solid transparent;
            border-right: 6px solid transparent;
            border-radius: 100%;
        }


        @-webkit-keyframes rotation {
            from {
                -webkit-transform: rotate(0deg);
            }
            to {
                -webkit-transform: rotate(359deg);
            }
        }

        @-moz-keyframes rotation {
            from {
                -moz-transform: rotate(0deg);
            }
            to {
                -moz-transform: rotate(359deg);
            }
        }

        @-o-keyframes rotation {
            from {
                -o-transform: rotate(0deg);
            }
            to {
                -o-transform: rotate(359deg);
            }
        }

        @keyframes rotation {
            from {
                transform: rotate(0deg);
            }
            to {
                transform: rotate(359deg);
            }
        }
    </style>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMiniConsole' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderLeftActions' runat='server'>
</asp:Content>
<asp:content contentplaceholderid="PlaceHolderMain" runat="server">
    <div id='spinnerOverlay' class="spinner-overlay">
      <div class="spinner"></div>
    </div>
    <h1>Manage Role Assignments</h1>
    <table class="multi-select-outer">
        <tr>
            <td>Site Group: </td>
            <td>
                <select name="siteGroup" id="siteGroup" class="site-group-select"></select>
                <div>
                    <span id="groupError" class="ms-formvalidation ms-csrformvalidation" role="alert">
                    </span>
                </div>
            </td>
        </tr>
        <tr>
            <td>Lists: </td>
            <td>
                <span class="multi-select-left">
                    <select name="listsAvailable" id="listsAvailable" class="list-available-select"  

multiple="multiple">
                    </select>
                </span>
                <span class="multi-select-center">
                    <button id="listAdd" class="list-add multi-select-button"type="button">
                        Add =&gt;
                    </button>
                    <br/><br/>
                    <button id="listRemove" class="list-remove multi-select-button"type="button">
                        &lt;= Remove
                    </button>
                </span>
                <span class="multi-select-right">
                    <select name="listsSelected" id="listsSelected" 
                        class="list-selected-select" multiple="multiple">
                    </select>            
                </span>
                <div>
                    <span id="listsError" class="ms-formvalidation ms-csrformvalidation" role="alert">
                    </span>
                </div>
            </td>
        </tr>
        <tr>
            <td>Role Definitions: </td>
            <td>
                <span class="multi-select-left">
                    <select name="roleDefinitionsAvailable" id="roleDefinitionsAvailable" 
                        class="roledefinition-available-select" multiple="multiple">
                    </select>
                </span>
                <span class="multi-select-center">
                    <button id="roleDefinitionAdd" class="roledefinition-add multi-select-button"type="button">
                        Add  =&gt;
                    </button>
                    <br/><br/>
                    <button id="roleDefinitionRemove" 
                        class="roledefinition-remove multi-select-button"type="button">
                            &lt;= Remove
                    </button>
                </span>
                <span class="multi-select-right">
                    <select name="roleDefinitionsSelected" id="roleDefinitionsSelected" 
                        class="roledefinition-selected-select" multiple="multiple">
                    </select>            
                </span>
                <div>
                    <span id="roleDefinitionsError" class="ms-formvalidation ms-csrformvalidation" role="alert">
                    </span>
                </div>
            </td>
        </tr>
        <tr>
            <td></td>
            <td>
                <button id="doItNow" type="button">
                Do It Now!
                </button>
            </td>
        </tr>
    </table>

    <script type="text/javascript">
    /*
MIT License

Copyright (c) 2018 Joe McShea

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
    */
        (function() {
            window.intellipoint = window.intellipoint || {};

            /**
             * Encapsulates all functionality for role definition management.
             */
            var rdm = {
                groupInitialized: false,
                listsInitialized: false,
                roleDefinitionsInitialized: false,
                connectionCount: 0,
                totalExpected: 0,
                totalRelease: 0,
                startTime: null,
                endTime: null,

                // change these to throttle, lowering connectionMax and increasing
                // interval will slow down time to complete, but also reduce load on the
                // server
                connectionMax: 5,
                interval: 1000,

                /**
                 * Initialize the select elements and setup event handlers on the buttons.
                 * @return undefined
                 */
                init: function() {
                    rdm.initGroupSelect();
                    rdm.initListSelect();
                    rdm.initRoleDefinitionSelect();

                    var doIt = document.getElementById("doItNow");
                    doIt.addEventListener("click", function(e) {
                        // construct an object that describes all the things we need to do
                        rdm.todo = {};
                        rdm.todo.principalId = document.getElementById("siteGroup").value;
                        rdm.todo.lists = rdm.getValues(document.getElementById("listsSelected"), true);
                        rdm.todo.roleDefIds = rdm.getValues(
                            document.getElementById("roleDefinitionsSelected"), false);
                        console.log(JSON.stringify(rdm.todo, null, 4));

                        // validate required inputs
                        var errors = rdm.validateRequired(rdm.todo.principalId.length < 1, "groupError");
                        errors += rdm.validateRequired(rdm.todo.lists.length < 1, "listsError");
                        errors += rdm.validateRequired(rdm.todo.roleDefIds.length < 1, "roleDefinitionsError");
                        
                        // reset connection statistics
                        rdm.connectionCount = 0;
                        rdm.totalReleased = 0;
                        rdm.totalExpected = rdm.todo.lists.length + 
                            (rdm.todo.lists.length * rdm.todo.roleDefIds.length);

                        // if nothing failed validation
                        if(errors === 0) {
                            // start setting role assignments
                            rdm.setRoleAssignments();
                        }
                    });
                },
                
                /**
                 * Set all role assignments on all lists.
                 * @return undefined
                 */
                setRoleAssignments: function() {
                    rdm.startTime = new Date();
                    try {
                        for(var i=0; i<rdm.todo.lists.length; i++) {
                            var list = rdm.todo.lists[i];
                            rdm.setRoleAssignmentsOnList(list);
                        }
                    }
                    catch(e) {
                        document.getElementById("spinnerOverlay").style.display = "none";
                    }
                },
                
                /**
                 * Set role assignments on a specific list.
                 * @param list {string} the title of the list.
                 * @return undefined
                 */
                setRoleAssignmentsOnList: function(list) {
                    var doListInternal = function() {
                        url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/lists/getbytitle('" + 
                            list + "')/hasuniqueroleassignments";
                        
                        fetch(url, {
                            method: 'GET',
                            credentials: 'include',
                            headers: {
                                'accept': 'application/json;odata=nometadata'
                            }
                        }).then(function(response) {
                            if (response.status !== 200) {
                                throw new Error(response.status + " " + response.statusText);
                            }
                            return response.json();
                        }).then(function(json) {
                            console.log("hasuniqueassignments(" + list + ")" +
                                " returned " + JSON.stringify(json,null,4));
                            if(json.value) {
                                rdm.removeGroupPermissions(list);
                            }
                            else {
                                rdm.breakRoleInheritance(list);
                            }
                        }).catch(function(error) {
                            alert(JSON.stringify(error, null, 4));
                        });
                    };
                    
                    // execute immediately if {connectionMax} is not exceeded, otherwise
                    // try again every {interval} milliseconds until {connectionMax} is 
                    // not exceeded, and then execute
                    rdm.executeOrDelayUntilConnectionAvailable(
                        doListInternal,
                        rdm.interval);
                },
                
                /**
                 * Break role inheritance on a list. Uses the same connection as setRoleAssignmentsOnList,
                 * so it doesn't have to reserve a connection, but does release the connection when
                 * finished.
                 * @param list {string} the list title
                 * @return undefined
                 */
                breakRoleInheritance: function(list) {
                    var url = _spPageContextInfo.webAbsoluteUrl + 
                        "/_api/web/lists/getbytitle('" + list + 
                        "')/breakroleinheritance(false)";
                    fetch(url, {
                        method: 'POST',
                        credentials: 'include',
                        headers: {
                            'accept': 'application/json;odata=nometadata',
                            'X-RequestDigest': rdm.getRequestDigest()
                        }
                    }).then(function(response) {
                        if (response.status !== 200) {
                            throw new Error(response.status + " " + response.statusText);
                        }
                        return response.json();                    
                    }).then(function(json) {
                        console.log("breakRoleInheritance(" + list + ")" + 
                            " returned " + JSON.stringify(json,null,4));
                        rdm.addRoleAssignments(list);
                    }).catch(function(error) {
                        alert(JSON.stringify(error, null, 4));
                    }).finally(function() {
                        rdm.releaseConnection();
                    });
                },
                
                /*
                 * Remove all permissions from a list for the group principal id. Uses the same connection 
                 * as setRoleAssignmentsOnList, so it doesn't have to reserve a connection, but does release 
                 * the connection when finished. This method only gets called if breakRoleInheritance does
                 * not (i.e. roll inheritance is already broken), so they can both safely share the same
                 * connection reservation.
                 * @param list {string} the title of the list
                 * @return undefined
                 */
                removeGroupPermissions: function(list) {
                    url = _spPageContextInfo.webAbsoluteUrl + 
                        "/_api/web/lists/getbytitle('" + list + "')/" +
                        "roleassignments/getbyprincipalid('" + rdm.todo.principalId + "')";
                    fetch(url, {
                        method: 'POST',
                        credentials: 'include',
                        headers: {
                            'accept': 'application/json;odata=nometadata',
                            'X-RequestDigest': rdm.getRequestDigest(),
                            'X-HTTP-Method': 'DELETE'
                        }
                    }).then(function(response) {
                        // 404 at this point just means there were no permissions for the
                        // principal id, you could get 404 if the list doesn't exist also,
                        // but since we already successfully call hasuniqueroleassignments
                        // on it, we don't so much have to worry about that, so ignore
                        // 404 returns, but we won't have json so just return the text, if
                        // the next then wants to process the json, they need to check if
                        // they got json, but the response json isn't really useful here anyway
                        if(response.status === 404) {
                            // response.text() returns the text of the 404 error page
                            // returned from the server
                            return response.text();
                        }
                        if(response.status === 200) {
                            // response.json() triggers catch because there is no payload,
                            // response.text() just returns an empty string
                            return response.text();
                        }
                        // if status is anything else, pass to catch
                        throw new Error(response.status + " " + response.statusText);                 
                    }).then(function(text) {
                        console.log("removeGroupPermissions(" + list + ")" +
                            " returned '" + text + "'");
                        // text is not useful as described above, if we get here,
                        // that's good enough to inidicate success
                        rdm.addRoleAssignments(list);
                    }).catch(function(error) {
                        alert(JSON.stringify(error, null, 4));
                    }).finally(function() {
                        rdm.releaseConnection();
                    });
                },
                
                /**
                 * Add all role assignments for a given list.
                 * @param list {string} the title of the list
                 * @return undefined
                 */
                addRoleAssignments: function(list) {
                    for(var i=0; i<rdm.todo.roleDefIds.length; i++) {
                        var roleDefId = rdm.todo.roleDefIds[i];
                        rdm.addARoleAssignment(list, roleDefId);
                    }
                },
                
                /**
                 * Add a single role assignment for a given list. This is where most of the connections are
                 * generated, (lists.length * roleDefIds.length) connections.
                 * @param list {string} the title of the list
                 * @param roleDefId {string} the id number of the role definition id
                 * @return undefined
                 */
                addARoleAssignment: function(list, roleDefId) {
                    var addARoleAssignmentInternal = function() {
                        url = _spPageContextInfo.webAbsoluteUrl +
                            "/_api/web/lists/getbytitle('" + list + "')/roleassignments" +       
                            "/addroleassignment(" +
                            "principalid='" + rdm.todo.principalId + "'," + 
                            "roledefid='" + roleDefId + "')";
                        fetch(url, {
                            method: 'POST',
                            credentials: 'include',
                            headers: {
                                'accept': 'application/json;odata=nometadata',
                                'X-RequestDigest': rdm.getRequestDigest()
                            }
                        }).then(function(response) {
                            if (response.status !== 200) {
                                throw new Error(response.status + " " + response.statusText);
                            }
                            return response.json();                    
                        }).then(function(json) {
                            console.log("addARoleAssignment(" + list + ", " + roleDefId + ")" +
                                " returned successfully!");
                        }).catch(function(error) {
                            alert(JSON.stringify(error, null, 4));
                        }).finally(function() {
                            rdm.releaseConnection();
                        });
                    };
                                        
                    // execute immediately if {connectionMax} is not exceeded, otherwise
                    // try again every {interval} milliseconds until {connectionMax} is 
                    // not exceeded, and then execute
                    rdm.executeOrDelayUntilConnectionAvailable(
                        addARoleAssignmentInternal,
                        rdm.interval);
                },
                
                /**
                 * Populate the site groups select using fetch.
                 * @return undefined
                 */
                initGroupSelect: function() {
                    var url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/sitegroups?$select=Id,Title";
                    fetch(url, {
                        method: 'GET',
                        credentials: 'include',
                        headers: new Headers({
                            'accept': 'application/json;odata=nometadata'
                        })
                    }).then(function(response) {
                        if (response.status !== 200) {
                            throw new Error(response.status + " " + response.statusText);
                        }
                        return response.json();
                    }).then(function(json) {
                        var groupSelect = document.getElementById("siteGroup");
                        var options = "<option></option>";
                        for (var i = 0; i < json.value.length; i++) {
                            var current = json.value[i];
                            options += "<option value='" + current.Id + "'>" + current.Title + "</option>"
                        }
                        groupSelect.innerHTML = options;
                        rdm.initialized("group");
                    }).catch(function(error) {
                        rdm.initialized("error");
                        alert(JSON.stringify(error, null, 4));
                    });
                },

                /*
                 * Populate the lists select using fetch and setup handlers for the add/remove buttons.
                 * @return undefined
                 */
                initListSelect: function() {
                    var url = _spPageContextInfo.webAbsoluteUrl + 
                        "/_api/web/lists?$select=Id,Title&$filter=Hidden eq false";
                    fetch(url, {
                        method: 'GET',
                        credentials: 'include',
                        headers: new Headers({
                            'accept': 'application/json;odata=nometadata'
                        })
                    }).then(function(response) {
                        if (response.status !== 200) {
                            throw new Error(response.status + " " + response.statusText);
                        }
                        return response.json();
                    }).then(function(json) {
                        var listsAvailable = document.getElementById("listsAvailable");
                        var options = "";
                        for (var i = 0; i < json.value.length; i++) {
                            var current = json.value[i];
                            options += "<option value='" + current.Id + "'>" + current.Title + "</option>"
                        }
                        listsAvailable.innerHTML = options;
                        rdm.initialized("lists");
                    }).catch(function(error) {
                        rdm.initialized("error");
                        alert(JSON.stringify(error, null, 4));
                    });
                    
                    // configure the add button
                    var listAdd = document.getElementById("listAdd");
                    listAdd.addEventListener("click", function(e) {
                        var available = document.getElementById("listsAvailable");
                        var selected = document.getElementById("listsSelected");
                        for(var i=available.options.length-1; i>=0; i--) {
                            var current = available.options[i];
                            if(current.selected) {
                                current.selected = false;
                                available.removeChild(current);
                                selected.appendChild(current)
                            }
                        }
                    });
                    
                    // configure the remove button
                    var listRemove = document.getElementById("listRemove");
                    listRemove.addEventListener("click", function(e) {
                        var available = document.getElementById("listsAvailable");
                        var selected = document.getElementById("listsSelected");
                        for(var i=selected.options.length-1; i>=0; i--) {
                            var current = selected.options[i];
                            if(current.selected) {
                                current.selected = false;
                                selected.removeChild(current)
                                available.appendChild(current);
                            }
                        }
                    });
                },

               /**
                * Populate the role definition select using fetch, and setup handlers for the add/remove buttons.
                * @return undefined
                */
                initRoleDefinitionSelect: function() {
                    var url = _spPageContextInfo.webAbsoluteUrl + "/_api/web/roledefinitions?$select=Id,Name";
                    fetch(url, {
                        method: 'GET',
                        credentials: 'include',
                        headers: new Headers({
                            'accept': 'application/json;odata=nometadata'
                        })
                    }).then(function(response) {
                        if (response.status !== 200) {
                            throw new Error(response.status + " " + response.statusText);
                        }
                        return response.json();
                    }).then(function(json) {
                        var roleDefinitionsAvailable = document.getElementById("roleDefinitionsAvailable");
                        var options = "";
                        for (var i = 0; i < json.value.length; i++) {
                            var current = json.value[i];
                            options += "<option value='" + current.Id + "'>" + current.Name + "</option>"
                        }
                        roleDefinitionsAvailable.innerHTML = options;
                        rdm.initialized("roleDefinitions");
                    }).catch(function(error) {
                        rdm.initialized("error");
                        alert(JSON.stringify(error, null, 4));
                    });
                    
                    // configure the add button
                    var defAdd = document.getElementById("roleDefinitionAdd");
                    defAdd.addEventListener("click", function(e) {
                        var available = document.getElementById("roleDefinitionsAvailable");
                        var selected = document.getElementById("roleDefinitionsSelected");
                        for(var i=available.options.length-1; i>=0; i--) {
                            var current = available.options[i];
                            if(current.selected) {
                                current.selected = false;
                                available.removeChild(current);
                                selected.appendChild(current)
                            }
                        }
                    });
                    
                    // configure the remove button
                    var listRemove = document.getElementById("roleDefinitionRemove");
                    listRemove.addEventListener("click", function(e) {
                        var available = document.getElementById("roleDefinitionsAvailable");
                        var selected = document.getElementById("roleDefinitionsSelected");
                        for(var i=selected.options.length-1; i>=0; i--) {
                            var current = selected.options[i];
                            if(current.selected) {
                                current.selected = false;
                                selected.removeChild(current)
                                available.appendChild(current);
                            }
                        }
                    });

                },

                /*
                 * Helper methods 
                 */
                 
                /**
                 * Reserve a connection for a callback to use if it would not exceed {connectionMax} connections.
                 * Othewise, set and interval for {interval} milliseconds and try again when called back.
                 * @param callback {function} the function to be called when a connection is available
                 * @param interval {interval} the number of milliseconds to wait before trying again
                 * @return undefined
                 */
                executeOrDelayUntilConnectionAvailable: function(callback, interval) {
                    if(rdm.reserveConnection()) {
                        callback();
                    }
                    else {
                        // check every 250ms if there is a connection available to us
                    	var i = setInterval(function() {
                            console.log("checking for connection again");
                            // returns false if we have too many connections
                            if(rdm.reserveConnection()) {
                                console.log("got connection after waiting");
                                // not too many connections, do our work
                                callback();
                                // release the timer
                                clearInterval(i);
                            }
                            // otherwise, try again in 250ms
                        }, interval);
                    }
                },
                
                /**
                 * Reserve a connection if one is available.
                 * @return {int} the 1-based id of the connection, or 0 if none available
                 */
                reserveConnection: function() {
                    console.log("reserving connection, count = " + rdm.connectionCount);
                    rdm.connectionCount++;
                    if(rdm.connectionCount > rdm.connectionMax) {
                    console.log("waiting for connection, count = " + rdm.connectionCount);
                        rdm.connectionCount--;
                        return 0;
                    }
                    document.getElementById("spinnerOverlay").style.display = "block";
                    return rdm.connectionCount;
                },
                
                /**
                 * Release a connection reservation.
                 * @return {int} the number of connections still reserved
                 */
                releaseConnection: function() {
                    console.log("releasing connection, count = " + rdm.connectionCount);
                    rdm.connectionCount--;
                    rdm.totalReleased++;
                    if(rdm.totalReleased === rdm.totalExpected) {
                        rdm.endTime = new Date();
                        var elapsed = Math.round((rdm.endTime - rdm.startTime) / 100);
                        console.log("elapsed time: " + elapsed/10);
                        document.getElementById("spinnerOverlay").style.display = "none";
                    }
                    return rdm.connectionCount;
                },
                
                /**
                 * Get the SharePoint request digest needed for POST operations that write to SharePoint. Refresh
                 * the digest as needed.
                 * @return {string} the request digest
                 */
                getRequestDigest: function() {
                    // update the form digest if necessary
                    UpdateFormDigest(
                        _spPageContextInfo.webServerRelativeUrl, 
                        _spFormDigestRefreshInterval);
                        
                    var input = document.getElementById("__REQUESTDIGEST");
                    if(!input)
                        return "";
                    return input.value;
                },
                
                /**
                 * Called as each select gets initialized with values. When all have been initialized,
                 * the modal spinner will be hidden.
                 * @param t {string} one of 'group', 'lists', or 'roleDefinitions'
                 * @return undefined
                 */
                initialized: function(t) {
                    switch(t) {
                    case 'group':
                        rdm.groupInitialized = true;
                        break;
                    case 'lists':
                        rdm.listsInitialized = true;
                        break;
                    case 'roleDefinitions':
                        rdm.roleDefinitionsInitialized = true;
                        break;
                    default:
                        rdm.groupInitialized = true;
                        rdm.listsInitialized = true;
                        rdm.roleDefinitionsInitialized = true;
                        break;
                    }
                    
                    if(rdm.groupInitialized && rdm.listsInitialized && rdm.roleDefinitionsInitialized) {
                        document.getElementById("spinnerOverlay").style.display = "none";
                    }
                },

                /**
                 * Add or clear a validation message for a required form input.
                 * @param condition {boolean} true if the field has a value, false otherwise
                 * @param id {string} The DOM id of the element that holds the error message
                 * @return {int} 1 on validation failed, 0 otherwise
                 */
                validateRequired: function(condition, id) {
                    if(condition) {
                        document.getElementById(id).innerText = "You must provide a value for this required field.";
                        return 1;
                    }
                    else {
                        document.getElementById(id).innerText = "";
                        return 0;
                    }
                },

                /**
                 * Get all values from a multiple selection input controle (note: not all selected values, but all
                 * values).
                 */
                getValues: function(select, preferText) {
                    var result = [];
                    preferText = preferText || false;

                    if(select && select.options) {
                        for(var i=0; i<select.options.length; i++) {
                            var current = select.options[i];
                            if(preferText) {
                                result.push(current.text);
                            }
                            else {
                                result.push(current.value || current.text);
                            }
                        }
                    }

                    return result;
                }
            };
            intellipoint.roleDefinitionManager = rdm;

            // load sp.js, call SP.ClientContext, and then call the init method of the
            // role definition manager
            SP.SOD.executeFunc("sp.js", "SP.ClientContext", function() {
                intellipoint.roleDefinitionManager.init();
            });
        })();

    </script>
</asp:content>
